using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System.Drawing.Drawing2D;
namespace Symcon.Lightridge.LRRUI.Controls
{
	public class SymbolsUtils 
	{
		static SymbolsUtils()
		{
			
		}

        //public static void CreateLabels(Symbol mysymbol)
        public static void CreateLabels(Node mysymbol)//Syncfusion compilation change..
		{
			CreateHeader(mysymbol);

			int	count =	0;
			int	_maxRow	= 3;
			int	_maxCol	= 3;
			for(int m=0;m<4;m++)
			{
				for	(int i = 0;	i <	_maxRow; i++)
				{
					for	(int j = 0;	j <	_maxCol; j++)
					{		
						string str = (string)i.ToString(Symcon.BusinessObjects.SymConverter.Culture) +	j.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						//-------------------------------------------------
						//|	00(Nothing)		01(PropValue 1)		02(Nothing)
						//|	10(PropName)	11(PropValue 2)		12(UOM)
						//|	20(Property	Description)		21(PropValue 3)		22(Nothing)
						//-------------------------------------------------
				
						switch(str)
						{
							case "00":
							{
								break;
							}
							case "01":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count + (count *	45)) ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
                                //Syncfusion compilation change..
                                //mysymbol.Labels.Add(smblLbl);
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}

							case "02":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count + (count *	45)) ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								//Syncfusion compilation change..
                                //mysymbol.Labels.Add(smblLbl);
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								
								InitLabelLookFeel(smblLbl);

                                //Syncfusion compilation change..
                                //smblLbl.Width = 10;
                                //smblLbl.Height = 10;
                                //smblLbl.EditStyle.Enabled = true;
                                //smblLbl.EditStyle.AllowResize = false; 
								break;
							}
							case "10":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -80;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
                                //Syncfusion compilation change..
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "11":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
                                //Syncfusion compilation change..
                                //mysymbol.Labels.Add(smblLbl);
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "12":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Near;
                                //Syncfusion compilation change..
                                //mysymbol.Labels.Add(smblLbl);
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
                                //smblLbl.Width = 20; //Syncfusion compilation change..
								break;
							}
							case "21":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count + (count *	45)) + 30;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
                                //Syncfusion compilation change..
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "22":
							{
								LRRLabel smblLbl = new LRRLabel();
                                //Syncfusion compilation change..
                                //smblLbl.Anchor = BoxPosition.TopLeft;
                                smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count + (count *	45))+ 30 ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
                                //Syncfusion compilation change..
                                //mysymbol.Labels.Add(smblLbl);
                                ((PathNode)mysymbol).Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
                                //Syncfusion compilation change..
                                //smblLbl.Width = 10;
                                //smblLbl.Height = 10;
                                //smblLbl.EditStyle.Enabled = true;
                                //smblLbl.EditStyle.AllowResize = false; 
								break;
							}
							default:
							{
								break;
							}
						}			
					}
				}
				count++;
			}
			CreateLinkLabel(mysymbol);

		}

        //private static void CreateHeader(Symbol mySymbol)
        private static void CreateHeader(Syncfusion.Windows.Forms.Diagram.Node mySymbol) //Syncfusion compilation change..
		{
			//Set the Header Label
			LRRLabel hsmblLbl = new LRRLabel();
            //Syncfusion compilation change..
            //hsmblLbl.Anchor	= BoxPosition.TopLeft;
            hsmblLbl.Anchor = Position.TopLeft;
			hsmblLbl.OffsetY = -15;
			hsmblLbl.HorizontalAlignment = StringAlignment.Center;
			hsmblLbl.VerticalAlignment = StringAlignment.Center;
            //Syncfusion compilation change..
            //mySymbol.Labels.Add(hsmblLbl);
            ((PathNode)mySymbol).Labels.Add(hsmblLbl);
			InitLabelLookFeel(hsmblLbl);
            //Syncfusion compilation change..
            //hsmblLbl.BackgroundStyle.Color = mySymbol.FillStyle.Color;
            hsmblLbl.BackgroundStyle.Color = ((FilledPath)mySymbol).FillStyle.Color;
			hsmblLbl.OffsetX = -60;
            //hsmblLbl.Width = 100; //Syncfusion compilation change..
		}

        //private static void CreateLinkLabel(Symbol mySymbol)
        private static void CreateLinkLabel(Node mySymbol)  //Syncfusion compilation change..
		{
			LRRLabel smblLbl = new LRRLabel();
			//InitLabelLookFeel(smblLbl);
            //Syncfusion compilation change..
            //smblLbl.Anchor = BoxPosition.Center;
            smblLbl.Anchor = Position.Center;
			smblLbl.Text = "Link";
			smblLbl.Name = "Link";
			smblLbl.Visible = false;
			smblLbl.HorizontalAlignment	= StringAlignment.Near;
            //Syncfusion compilation change..
            //mySymbol.Labels.Add(smblLbl);
            ((PathNode)mySymbol).Labels.Add(smblLbl);
		}

        //private static void	InitLabelLookFeel(SymbolLabel lbl)
        private static void InitLabelLookFeel(Syncfusion.Windows.Forms.Diagram.Label lbl) //Syncfusion compilation change..
		{
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.FontStyle.Name = "Arial";
			lbl.FontStyle.Family = "Arial";
			lbl.FontStyle.PointSize = 9f;
            //lbl.EditStyle.Enabled = true; //Syncfusion compilation change..
			lbl.WrapText = false;
			lbl.NoClip = false;
            //Syncfusion compilation change..
            //lbl.Width = 40f;
            //lbl.Height = 15;
		}
	}
}
